proc SetTkDefaultOptions {} { 

    set TkDefault(prioLevel)    10
    set TkDefault(font)         -*-helvetica-medium-r-normal-*-14-*-*-*-*-*-*-*
    set TkDefault(bold_font)    -*-helvetica-bold-r-normal-*-14-*-*-*-*-*-*-*
    set TkDefault(menu_font)    -*-helvetica-bold-r-normal-*-14-*-*-*-*-*-*-*
    set TkDefault(italic_font)  -*-helvetica-bold-o-normal-*-14-*-*-*-*-*-*-*
    #set TkDefault(fixed_font)   -*-courier-medium-r-*-*-14-*-*-*-*-*-*-*

    option add *Font		$TkDefault(font) $TkDefault(prioLevel)
    option add *font		$TkDefault(font) $TkDefault(prioLevel)
    option add *Menu.font	$TkDefault(menu_font) $TkDefault(prioLevel)
    option add *Menubutton.font	$TkDefault(menu_font) $TkDefault(prioLevel)
    option add *Label.font      $TkDefault(bold_font) $TkDefault(prioLevel)
    option add *Scale.font	$TkDefault(italic_font) $TkDefault(prioLevel)

    set TkDefault(bg)           lightgray
    set TkDefault(fg)           black

    set TkDefault(dark1_bg)     gray86
    set TkDefault(dark1_fg)     black
    #set TkDefault(dark2_bg)     gray77
    #set TkDefault(dark2_fg)     black
    set TkDefault(inactive_bg)  gray77
    set TkDefault(inactive_fg)  black

    set TkDefault(light1_bg)    gray92
    #set TkDefault(light1_fg)    white
    #set TkDefault(light2_bg)    gray95
    #set TkDefault(light2_fg)    white

    set TkDefault(active_bg)    $TkDefault(dark1_bg)
    set TkDefault(active_fg)    $TkDefault(fg)
    set TkDefault(disabled_fg)  gray55

    set TkDefault(input1_bg)    gray95
    set TkDefault(input2_bg)    gray95
    set TkDefault(output1_bg)   $TkDefault(dark1_bg)
    set TkDefault(output2_bg)   $TkDefault(bg)

    set TkDefault(select_fg)    black
    set TkDefault(select_bg)    lightblue

    set TkDefault(selector)	yellow

    option add *background 		$TkDefault(bg) 10
    option add *Background		$TkDefault(bg) $TkDefault(prioLevel)
    option add *background		$TkDefault(bg) $TkDefault(prioLevel)
    option add *Foreground		$TkDefault(fg) $TkDefault(prioLevel)
    option add *foreground		$TkDefault(fg) $TkDefault(prioLevel)
    option add *activeBackground	$TkDefault(active_bg) $TkDefault(prioLevel)
    option add *activeForeground	$TkDefault(active_fg) $TkDefault(prioLevel)
    option add *HighlightBackground	$TkDefault(bg) $TkDefault(prioLevel)
    option add *selectBackground	$TkDefault(select_bg) $TkDefault(prioLevel)
    option add *selectForeground	$TkDefault(select_fg) $TkDefault(prioLevel)
    option add *selectBorderWidth	0 $TkDefault(prioLevel)
    option add *Menu.selectColor	$TkDefault(selector) $TkDefault(prioLevel)
    option add *MenuFrame.background	    beige $TkDefault(prioLevel)
    option add *Menubutton.background	    beige $TkDefault(prioLevel)
    option add *Menubutton.activeBackground yellow $TkDefault(prioLevel)
    option add *NoteBook.activeBackground yellow $TkDefault(prioLevel)

    option add *Menubutton.padY		5 $TkDefault(prioLevel)
    option add *Button.borderWidth	2 $TkDefault(prioLevel)
    option add *Button.anchor		c $TkDefault(prioLevel)
    option add *Checkbutton.selectColor	$TkDefault(selector) $TkDefault(prioLevel)
    option add *Radiobutton.selectColor	$TkDefault(selector) $TkDefault(prioLevel)
    option add *Entry.relief		sunken $TkDefault(prioLevel)
    option add *Entry.highlightBacground	$TkDefault(bg) $TkDefault(prioLevel)
    option add *Entry.background	$TkDefault(input1_bg) $TkDefault(prioLevel)
    option add *Entry.foreground	black $TkDefault(prioLevel)
    option add *Entry.insertBackground	black $TkDefault(prioLevel)
    option add *Label.anchor		w $TkDefault(prioLevel)
    option add *Label.borderWidth	0 $TkDefault(prioLevel)
    option add *Listbox.background	$TkDefault(light1_bg) $TkDefault(prioLevel)
    option add *Listbox.relief		sunken $TkDefault(prioLevel)
    option add *Scale.foreground	$TkDefault(fg) $TkDefault(prioLevel)
    option add *Scale.activeForeground	$TkDefault(bg) $TkDefault(prioLevel)
    option add *Scale.background	$TkDefault(bg) $TkDefault(prioLevel)
    option add *Scale.sliderForeground	$TkDefault(bg) $TkDefault(prioLevel)
    option add *Scale.sliderBackground	$TkDefault(light1_bg) $TkDefault(prioLevel)
    option add *Scrollbar.background	$TkDefault(bg) $TkDefault(prioLevel)
    option add *Scrollbar.troughColor	$TkDefault(light1_bg) $TkDefault(prioLevel)
    option add *Scrollbar.relief	sunken $TkDefault(prioLevel)
    option add *Scrollbar.borderWidth	1 $TkDefault(prioLevel)
    option add *Scrollbar.width		15 $TkDefault(prioLevel)
    option add *Text.background		$TkDefault(input1_bg) $TkDefault(prioLevel)
    option add *Text.relief		sunken $TkDefault(prioLevel)
    . config -background                $TkDefault(bg)
}
SetTkDefaultOptions